#if 0


#define Uses_TRect
#define Uses_TApplication
#define Uses_TProgram
#define Uses_TDialog
#define Uses_TDeskTop
#define Uses_TStatusLine
#define Uses_TMenuBar

#include <dos.h>
#include <tv.h>
#ifndef __EMX__
  #include <dos.h>
#else
  #include <stdlib.h>
  #include <strstrea.h>
  #include <iomanip.h>
#endif

  class strmtst_object : public TApplication {
    public:
      strmtst_object();
      virtual void run();
  };

strmtst_object::strmtst_object() :
  TApplication(),
  TProgInit(&strmtst_object::initStatusLine,
            &strmtst_object::initMenuBar,
            &strmtst_object::initDeskTop)
{

}

void strmtst_object::run() {
  TDialog *dlg;

  dlg = new TDialog (TRect (0, 0, 50, 10), "Generating resource files");
  if (dlg != NULL) {
    dlg->options |= ofCentered;
    insert(dlg);
    sleep(1);
    TObject::destroy(dlg); // Here's the interesting line
  };
}

int main() {
  #ifdef __EMX__
    ostrstream out;
    cerr << "\n";
  #endif
  strmtst_object *strmtst;
  strmtst = new strmtst_object;
  if (strmtst != NULL) {
    strmtst->run();
    TObject::destroy(strmtst); // But here it works
  };
}

#endif

#if 1

#define Uses_TRect
#define Uses_TApplication
#define Uses_TProgram
#define Uses_TDialog
#define Uses_TDeskTop
#define Uses_TStatusLine
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_fpstream
#define Uses_TResourceFile
#define Uses_TKeys
#define Uses_TStaticText
#define Uses_TButton
#define Uses_TStrListMaker
#define Uses_TStringList
#define Uses_TStreamableClass

#if 0
  #include <dos.h>
#endif
#include <tv.h>
#if 0 // ndef __EMX__
  #include <dos.h>
#else
  #include <stdlib.h>
  #include <strstrea.h>
  #include <iomanip.h>
#endif

__link ( RGroup )
__link ( RStringCollection )
__link ( RResourceCollection )
__link ( RStringList )
__link ( RMenuBar )
__link ( RDialog )
__link ( RStaticText )
__link ( RButton )

  class strmtst_object : public TApplication {
    public:
      strmtst_object();
      virtual void run();
      void make_resource();
  };

TMenuBar *makemenu() {
	TRect r(0, 0, 80, 1);
	TMenuBar *menu;
	menu = new TMenuBar(r,
				*new TSubMenu( "~T~est program", hcNoContext) +
						*new TMenuItem( "~A~bout", 1000, 0, hcNoContext, "" ) +
						*new TMenuItem( "~H~elp",  1000,   kbF1, hcNoContext, "f1" ) +
						newLine() +
            *new TMenuItem( "~D~OS Shell", 1000, kbAltO, hcNoContext, "alt+o" ) +
            newLine() +
						*new TMenuItem( "E~x~it", cmQuit, kbAltX, hcNoContext, "alt+x") +
				*new TSubMenu( "~A~nother menu", hcNoContext) +
            *new TMenuItem( "~I~nformation", 1000, 0, hcNoContext, "") +
            newLine() +
            *new TMenuItem( "Test ~1~", 1000, kbAltS, hcNoContext, "alt+s" ) +
            *new TMenuItem( "Test ~2~", 1000, kbCtrlEnter, hcNoContext, "ctrl+enter" )

				);
	return menu;
}

strmtst_object::strmtst_object() :
  TApplication(),
  TProgInit(&strmtst_object::initStatusLine,
            &strmtst_object::initMenuBar,
            &strmtst_object::initDeskTop)
{

}

void strmtst_object::run() {
  make_resource();
}

void strmtst_object::make_resource() {
  char resource_name[] = "test.res";
  TDialog *dlg;
  TStaticText *txt;
  fpstream *s;
  TResourceFile* r;
  TMenuBar *m;

  dlg = new TDialog (TRect (0, 0, 50, 10), "Generating resource file");

  if (dlg != NULL) {
    dlg->options |= ofCentered;
    insert(dlg);

    s = new fpstream (resource_name, ios::out|ios::binary);
  	r = new TResourceFile (s);

    if (r != NULL) {

      txt = new TStaticText(TRect(1, 1, 48, 8), "\n\003Generating menu");
      dlg->insert(txt);
  	  m = makemenu();
      r->put(m, "mainmenu");
      destroy(m);
      destroy(txt);

      destroy(r);
    };
    destroy(dlg);
  };

}

int main() {
  #ifdef __EMX__
    ostrstream out;
    cerr << "\n";
  #endif
  strmtst_object *strmtst;
  strmtst = new strmtst_object;
  if (strmtst != NULL) {
    strmtst->run();
    TObject::destroy(strmtst);
  };
  return 0;
}

#endif

