/*------------------------------------------------------------*/
/* filename -       smenubox.cpp                              */
/*                                                            */
/* Registeration objects for all classes                      */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision -  Version 1.0                             */
/*                                                            */
/*                                                            */
/*    Copyright (c) 1991 by Borland International             */
/*    All Rights Reserved.                                    */
/*                                                            */
/*    This file written by Jrn Sierwald                      */
/*                                                            */
/*------------------------------------------------------------*/
#define Uses_TBackground
#define Uses_TButton
#define Uses_TChDirDialog
#define Uses_TCheckBoxes
#define Uses_TCluster
#define Uses_TColorDialog
#define Uses_TColorDisplay
#define Uses_TColorGroupList
#define Uses_TColorItemList
#define Uses_TColorSelector
#define Uses_TDeskTop
#define Uses_TDialog
#define Uses_TDirCollection
#define Uses_TDirEntry
#define Uses_TDirListBox
#define Uses_TEditor
#define Uses_TEditWindow
#define Uses_TFileCollection
#define Uses_TFileDialog
#define Uses_TFileEditor
#define Uses_TFileInfoPane
#define Uses_TFileInputLine
#define Uses_TFileList
#define Uses_TFrame
#define Uses_TGroup
#define Uses_THistory
#define Uses_TIndicator
#define Uses_TInputLine
#define Uses_TLabel
#define Uses_TListBox
#define Uses_TListViewer
#define Uses_TMemo
#define Uses_TMenuBar
#define Uses_TMenuBox
#define Uses_TMenuView
#define Uses_TMonoSelector
#define Uses_TParamText
#define Uses_TRadioButtons
#define Uses_TResourceCollection
#define Uses_TScrollBar
#define Uses_TScroller
#define Uses_TStaticText
#define Uses_TStatusLine
#define Uses_TStreamableClass
#define Uses_TStringCollection
#define Uses_TStringList
#define Uses_TView
#define Uses_TWindow
#include <tv.h>

__link( RButton )
__link( RCluster )
__link( RDialog )
__link( RDirListBox )
__link( RFileInputLine )
__link( RFileList )
__link( RFrame )
__link( RGroup )
__link( RInputLine )
__link( RLabel )
__link( RListViewer )
__link( RScrollBar ) 
__link( RStaticText )
__link( RStringCollection )
__link( RView )
__link( RWindow )

TStreamableClass RBackground( TBackground::name,
                              TBackground::build,
                              __DELTA(TBackground)
                            );

TStreamableClass RButton( TButton::name,
                          TButton::build,
                          __DELTA(TButton)
                        );

TStreamableClass RChDirDialog( TChDirDialog::name,
                               TChDirDialog::build,
                               __DELTA(TChDirDialog)
                             );

TStreamableClass RCheckBoxes( TCheckBoxes::name,
                              TCheckBoxes::build,
                              __DELTA(TCheckBoxes)
                            );

TStreamableClass RColorSelector( TColorSelector::name,
                                 TColorSelector::build,
                                 __DELTA(TColorSelector)
                               );

TStreamableClass RMonoSelector( TMonoSelector::name,
                                TMonoSelector::build,
                                __DELTA(TMonoSelector)
                              );

TStreamableClass RColorDisplay( TColorDisplay::name,
                                TColorDisplay::build,
                                __DELTA(TColorDisplay)
                              );

TStreamableClass RColorGroupList( TColorGroupList::name,
                                  TColorGroupList::build,
                                  __DELTA(TColorGroupList)
                                );


TStreamableClass RColorItemList( TColorItemList::name,
                                 TColorItemList::build,
                                 __DELTA(TColorItemList)
                               );

TStreamableClass RColorDialog( TColorDialog::name,
                               TColorDialog::build,
                               __DELTA(TColorDialog)
                             );

TStreamableClass RCluster( TCluster::name,
                           TCluster::build,
                           __DELTA(TCluster)
                         );

TStreamableClass RDeskTop( TDeskTop::name,
                           TDeskTop::build,
                           __DELTA(TDeskTop)
                         );

TStreamableClass RDialog( TDialog::name,
                          TDialog::build,
                          __DELTA(TDialog)
                        );

TStreamableClass RDirCollection( TDirCollection::name,
                                 TDirCollection::build,
                                 __DELTA(TDirCollection)
                               );

TStreamableClass RDirListBox( TDirListBox::name,
                              TDirListBox::build,
                              __DELTA(TDirListBox)
                            );

TStreamableClass RIndicator( TIndicator::name,
                             TIndicator::build,
                             __DELTA(TIndicator)
                           );

TStreamableClass REditor( TEditor::name,
                          TEditor::build,
                          __DELTA(TEditor)
                        );

TStreamableClass RMemo( TMemo::name,
                        TMemo::build,
                        __DELTA(TMemo)
                      );

TStreamableClass RFileEditor( TFileEditor::name,
                              TFileEditor::build,
                              __DELTA(TFileEditor)
                            );

TStreamableClass REditWindow( TEditWindow::name,
                              TEditWindow::build,
                              __DELTA(TEditWindow)
                            );

TStreamableClass RFileCollection( TFileCollection::name,
                                  TFileCollection::build,
                                  __DELTA(TFileCollection)
                                );

TStreamableClass RFileDialog( TFileDialog::name,
                              TFileDialog::build,
                              __DELTA(TFileDialog)
                            );

TStreamableClass RFileList( TFileList::name,
                            TFileList::build,
                            __DELTA(TFileList)
                          );

TStreamableClass RFileInfoPane( TFileInfoPane::name,
                                TFileInfoPane::build,
                                __DELTA(TFileInfoPane)
                              );

TFileInputLine::TFileInputLine( StreamableInit ) :
                TInputLine( streamableInit)
{
}

TStreamable *TFileInputLine::build()
{
    return new TFileInputLine( streamableInit );
}

TStreamableClass RFileInputLine( TFileInputLine::name,
                                 TFileInputLine::build,
                                __DELTA(TFileInputLine)
                               );

TStreamableClass RFrame( TFrame::name,
                         TFrame::build,
                         __DELTA(TFrame)
                       );

TStreamableClass RGroup( TGroup::name,
                         TGroup::build,
                         __DELTA(TGroup)
                       );

TStreamableClass RHistory( THistory::name,
                           THistory::build,
                           __DELTA(THistory)
                         );

TStreamableClass RInputLine( TInputLine::name,
                             TInputLine::build,
                             __DELTA(TInputLine)
                           );

TStreamableClass RLabel( TLabel::name,
                         TLabel::build,
                         __DELTA(TLabel)
                       );

TStreamableClass RListBox( TListBox::name,
                           TListBox::build,
                           __DELTA(TListBox)
                         );

TStreamableClass RListViewer( TListViewer::name,
                              TListViewer::build,
                              __DELTA(TListViewer)
                            );

TStreamableClass RMenuBar( TMenuBar::name,
                           TMenuBar::build,
                           __DELTA(TMenuBar)
                         );

TStreamableClass RMenuBox( TMenuBox::name,
                           TMenuBox::build,
                           __DELTA(TMenuBox)
                         );

TStreamableClass RMenuView( TMenuView::name,
                            TMenuView::build,
                            __DELTA(TMenuView)
                          );

TStreamableClass RParamText( TParamText::name,
                              TParamText::build,
                              __DELTA(TParamText)
                            );

TStreamableClass RRadioButtons( TRadioButtons::name,
                                TRadioButtons::build,
                                __DELTA(TRadioButtons)
                              );

TStreamableClass RResourceCollection( TResourceCollection::name,
                                      TResourceCollection::build,
                                      __DELTA(TResourceCollection)
                                    );

TStreamableClass RScrollBar( TScrollBar::name,
                              TScrollBar::build,
                              __DELTA(TScrollBar)
                           );

TStreamableClass RScroller( TScroller::name,
                             TScroller::build,
                             __DELTA(TScroller)
                          );

TStreamableClass RStaticText( TStaticText::name,
                              TStaticText::build,
                              __DELTA(TStaticText)
                            );

TStreamableClass RStatusLine( TStatusLine::name,
                              TStatusLine::build,
                              __DELTA(TStatusLine)
                            );

TStreamableClass RStringCollection( TStringCollection::name,
                                    TStringCollection::build,
                                    __DELTA(TStringCollection)
                                  );

TStreamableClass RStringList( TStringList::name,
                              TStringList::build,
                              __DELTA(TStringList)
                            );

TStreamableClass RView( TView::name,
                        TView::build,
                        __DELTA(TView)
                      );

TStreamableClass RWindow( TWindow::name,
                          TWindow::build,
                          __DELTA(TWindow)
                        );

 
