#include <iostream.h>
#include <stdlib.h>
#include <process.h>

#define INCL_DOSPROCESS
#define INCL_DOSMEMMGR
#define INCL_MOU
#include <os2.h>

PHMOU mou;
HMOU mouseHandle;
MOUEVENTINFO info;
USHORT type = 1; // blocking read
TID pid;

void _Optlink thread1( void* arg ) {
  int retVal=0;
  cerr << "T1 started" << endl;
  while (1) {
    if (retVal = MouReadEventQue(&info, &type, mouseHandle)) {
      break;
    };
  } /* endwhile */
  cerr << "T1: end of function" << retVal << endl;
};

int main() {
/*
  int errCode;
  cerr << &mou << endl;
  void *pv;
  if (errCode = DosAllocMem(&pv,sizeof(HMOU),PAG_READ | PAG_WRITE | OBJ_TILE)) cerr << "No Mem " << errCode << "\n";
  mou = (HMOU*) pv;
  if (DosAllocMem(&pv,sizeof(MOUEVENTINFO),PAG_READ | PAG_WRITE | OBJ_TILE)) cerr << "No Mem\n";
  info = (MOUEVENTINFO*) pv;
  cerr << mou << " " << info << endl;
*/
  int errCode;
  if (errCode = DosAllocMem((void**)&mou,sizeof(HMOU),fALLOC | OBJ_TILE)) cerr << "No Mem " << errCode << "\n";
//  mou = &mouseHandle;
  cerr << mou << endl;
  MouOpen ((PSZ) 0, mou);
  pid = _beginthread( thread1, NULL, 16384, NULL );
  DosSleep(2000);
  cerr << "Now killing.." << endl;
  DosKillThread(pid);
  cerr << DosWaitThread(&pid,0) << " " << pid << endl;
  DosSleep(2000);
  cerr << "Now close mouse" << endl;
  MouClose(mouseHandle);
  DosSleep(2000);
  cerr << "Now exit program";
  return 0;
};

