/*------------------------------------------------------------*/
/* filename -       syserr.cpp                                */
/*                                                            */
/* function(s)                                                */
/*          TSystemError member functions                     */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision -  Version 1.0                             */
/*                                                            */
/*                                                            */
/*    Copyright (c) 1991 by Borland International             */
/*    All Rights Reserved.                                    */
/*                                                            */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    I think that this module is useless in OS/2.            */
/*    I left it just in case someone wants to port TV to      */
/*    a DOS-Compiler. JS                                      */
/*                                                            */
/*------------------------------------------------------------*/

#define Uses_TDrawBuffer
#define Uses_TSystemError
#define Uses_TScreen
#include <tv.h>

#if !defined( __CONIO_H )
#include <conio.h>
#endif  // __CONIO_H

#if !defined( __STDIO_H )
#include <stdio.h>
#endif  // __STDIO_H

#if !defined( __STRING_H )
#include <String.h>
#endif  // __STRING_H

#if !defined( __MATH_H )
#include <Math.h>
#endif  // __MATH_H

Boolean TSystemError::ctrlBreakHit = False;
short ( * TSystemError::sysErrorFunc )( short, uchar ) = &TSystemError::sysErr;
ushort TSystemError::sysColorAttr = 0x4E4F;
ushort TSystemError::sysMonoAttr = 0x7070;
Boolean TSystemError::saveCtrlBreak = False;
Boolean TSystemError::sysErrActive = False;
Boolean TSystemError::inIDE = False;

const SecretWord = 1495;
const productID  =  136;

TSystemError::TSystemError()
{
//    resume();
}

TSystemError::~TSystemError()
{
//    suspend();
}

void TSystemError::resume() {
  // no error handling at all in OS/2.
};

void TSystemError::suspend() {
};

static int getakey()
{
#if defined(__TV4BCC__) || defined(__TV4TS__) || defined(__TV4WATCOM__) || defined(__TV4DJ__)
  if (kbhit()) {
    return getch();
  } else {
    return 0;
  };
#endif
#ifdef __TV4ICC__
  if (_kbhit()) {
    return _getch();
  } else {
    return 0;
  };
#endif
#ifdef __TV4EMX__
  return 0; // isn't used anyway..
#endif
}

ushort TSystemError::selectKey()
{
    ushort crsrType = TScreen::getCursorType();

    TScreen::setCursorType( 0x2000 );

    while( getakey() )
        ;
    
    int ch = getakey() & 0xFF;
    while( ch != 13 && ch != 27 )
        ch = getakey() & 0xFF;

    TScreen::setCursorType( crsrType );
    return ch == 27;
}

short TSystemError::sysErr( short errorCode, uchar drive )
{
    ushort c = ( (TScreen::screenMode & 0x00fF) != TDisplay::smMono  ) ?
                                        sysColorAttr : sysMonoAttr;
    char s[ 63 ];
    TDrawBuffer b;

    if (errorCode < sizeof(errorString)/sizeof(*errorString) )
      sprintf( s, errorString[ errorCode ], drive + 'A' );
    else
      sprintf( s, "Unknown error %d on drive %c", errorCode, drive + 'A' );

    b.moveChar( 0, ' ', c, 80);
    b.moveCStr( 1, s, c);
    b.moveCStr( 79-cstrlen(sRetryOrCancel), sRetryOrCancel, c);
    swapStatusLine(b);
    int res = selectKey();
    swapStatusLine(b);
    return res;
}

