/*-------------------------------------------------------------------*/
/* filename -       tapplica.cpp                                     */
/*                                                                   */
/* function(s)                                                       */
/*          TApplication member functions (constructor & destructor) */
/*-------------------------------------------------------------------*/

/*-------------------------------------------------------------------*/
/*                                                                   */
/*    Turbo Vision -  Version 1.0                                    */
/*                                                                   */
/*                                                                   */
/*    Copyright (c) 1987,1988,1990 by Borland International          */
/*    All Rights Reserved.                                           */
/*                                                                   */
/*-------------------------------------------------------------------*/

#define Uses_TSystemError
#define Uses_TEventQueue
#define Uses_TScreen
#define Uses_TObject
#define Uses_TMouse
#define Uses_TApplication
#define Uses_TOS2Handles
#include <tv.h>
#ifdef __TV4OS2__
#include <iostream.h>
#endif

// The Initialization of TurboVision was done by the constructors
// of the following static Objects.
// I have changed this behaviour, because all threads are killed before the
// destructors for the static objects are called.
// Initialization is now done by TApplication::TApplication(...)
// JS

#if 0
#ifdef __TV4EMX__
// This is for the iostreams lib I use.
// Is you use the original lib, remove this.
class InitTheDamnIOStreams {
public:
  InitTheDamnIOStreams() { _init_standard(); };
};
InitTheDamnIOStreams lahjkbqwfb;
#endif
#endif

#ifdef __TV4OS2__
static TOS2Handles aTOS2Handles;
#endif
TMouse TEventQueue::mouse;
static TScreen tsc;
static TEventQueue teq;
static TSystemError sysErr;

void initHistory();
void doneHistory();

TApplication::TApplication() :
    TProgInit( &TApplication::initStatusLine,
                  &TApplication::initMenuBar,
                  &TApplication::initDeskTop
                )
{
    initHistory();
}

TApplication::~TApplication()
{
    doneHistory();
}

void TApplication::suspend()
{
#if 0
    TSystemError::suspend();
    TEventQueue::suspend();
    TScreen::suspend();
#ifdef __TV4OS2__
    TOS2Handles::suspend();
#endif
#endif
  TSystemInit::suspend();
}

void TApplication::resume()
{
  TSystemInit::resume();
#if 0
#ifdef __TV4OS2__
    TOS2Handles::resume();
#endif
    TScreen::resume();
    TEventQueue::resume();
    TSystemError::resume();
#endif
}
